Настройка фонового изображение загрузчика Grub 2

Руководства, вопросы, обсуждения
Правила форума
Правильно сформулированный вопрос и его грамотное оформление способствует высокой вероятности получения достаточно содержательного и по существу ответа.

Автор темы
NikolS
Сообщения: 19
Зарегистрирован: 22 янв 2017, 17:38
Благодарил (а): 4 раза
Поблагодарили: 1 раз

Настройка фонового изображение загрузчика Grub 2

Сообщение NikolS » 26 янв 2017, 15:42

Не получается установить свой фон на grub2-02
Мои действия:
sudo xed /etc/grub.d/05_debian_theme
нашел эту строчку следующего содержания:

if set_background_image «/usr/share/images/desktop-base/desktop-grub.png»; then
В моем установленном дистрибутиве Mint почему-то совсем не оказалось этого каталога. Дойдя до /usr/share/, я создал остальную цепочку.

cd /usr/share
sudo mkdir images
cd /usr/share/images
sudo mkdir desktop-base

переместил файл изображения desktop-grub.png
sudo mv desktop-grub.png /usr/share/images/desktop-base

далее
sudo update-grub
и рестарт
Результатов 0 !

Аватара пользователя

Seisan
Сообщения: 91
Зарегистрирован: 18 ноя 2016, 12:35
Решено: 1
Откуда: Средний Урал
Благодарил (а): 20 раз
Поблагодарили: 82 раза

Настройка фонового изображение загрузчика Grub 2

Сообщение Seisan » 26 янв 2017, 15:57

Grub Customizer в помощь....sudo add-apt-repository ppa:danielrichter2007/grub-customizer &&
sudo apt-get update &&
sudo apt-get install grub-customizer
Linux Mint 17.3 Xfce


Автор темы
NikolS
Сообщения: 19
Зарегистрирован: 22 янв 2017, 17:38
Благодарил (а): 4 раза
Поблагодарили: 1 раз

Настройка фонового изображение загрузчика Grub 2

Сообщение NikolS » 26 янв 2017, 16:08

Seisan, значит все таки через кастомайзер?

Аватара пользователя

Seisan
Сообщения: 91
Зарегистрирован: 18 ноя 2016, 12:35
Решено: 1
Откуда: Средний Урал
Благодарил (а): 20 раз
Поблагодарили: 82 раза

Настройка фонового изображение загрузчика Grub 2

Сообщение Seisan » 26 янв 2017, 16:22

NikolS, я просто не стал лишний раз в системные файлы лезть , когда есть оптимальный вариант ( тем более отточенный).
Linux Mint 17.3 Xfce


Автор темы
NikolS
Сообщения: 19
Зарегистрирован: 22 янв 2017, 17:38
Благодарил (а): 4 раза
Поблагодарили: 1 раз

Настройка фонового изображение загрузчика Grub 2

Сообщение NikolS » 26 янв 2017, 17:44

Код: Выделить всё

#!/bin/sh
set -e

# grub-mkconfig helper script.
# Copyright (C) 2010  Alexander Kurtz <kurtz.alex@googlemail.com>
#
# GRUB is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# GRUB is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GRUB.  If not, see <http://www.gnu.org/licenses/>.

# Include the GRUB helper library for grub-mkconfig.
. /usr/share/grub/grub-mkconfig_lib

# We want to work in /boot/grub/ only.
test -d /boot/grub; cd /boot/grub

# Set the location of a possibly necessary cache file for the background image.
# NOTE: This MUST BE A DOTFILE to avoid confusing it with user-defined images.
BACKGROUND_CACHE=".background_cache"

set_default_theme(){
	case $GRUB_DISTRIBUTOR in
		Tanglu|Ubuntu|Kubuntu)
			# Set a monochromatic theme for Tanglu/Ubuntu.
			echo "${1}set menu_color_normal=white/black"
			echo "${1}set menu_color_highlight=black/light-gray"

			if [ -e /usr/share/plymouth/themes/default.grub ]; then
				sed "s/^/${1}/" /usr/share/plymouth/themes/default.grub
			fi
			# For plymouth backward compatiblity. Can be removed
			# after xenial.
			if [ -e /lib/plymouth/themes/default.grub ]; then
				sed "s/^/${1}/" /lib/plymouth/themes/default.grub
			fi
			;;
		*)
			# Set the traditional Debian blue theme.
			echo "${1}set menu_color_normal=cyan/blue"
			echo "${1}set menu_color_highlight=white/blue"
			;;
	esac
}

module_available(){
	local module
	for module in "${1}.mod" */"${1}.mod"; do
		if [ -f "${module}" ]; then
			return 0
		fi
	done
	return 1
}

set_background_image(){
	# Step #1: Search all available output modes ...
	local output
	for output in ${GRUB_TERMINAL_OUTPUT}; do
		if [ "x$output" = "xgfxterm" ]; then
			break
		fi
	done

	# ... and check if we are able to display a background image at all.
	if ! [ "x${output}" = "xgfxterm" ]; then
		return 1
	fi

	# Step #2: Check if the specified background image exists.
	if ! [ -f "${1}" ]; then
		return 2
	fi

	# Step #3: Search the correct GRUB module for our background image.
	local reader
	case "${1}" in
		*.jpg|*.JPG|*.jpeg|*.JPEG) reader="jpeg";;
		*.png|*.PNG) reader="png";;
		*.tga|*.TGA) reader="tga";;
		*) return 3;; # Unknown image type.
	esac

	# Step #4: Check if the necessary GRUB module is available.
	if ! module_available "${reader}"; then
		return 4
	fi

	# Step #5: Check if GRUB can read the background image directly.
	# If so, we can remove the cache file (if any). Otherwise the backgound
	# image needs to be cached under /boot/grub/.
	if is_path_readable_by_grub "${1}"; then
		rm --force "${BACKGROUND_CACHE}.jpeg" \
			"${BACKGROUND_CACHE}.png" "${BACKGROUND_CACHE}.tga"
	elif cp "${1}" "${BACKGROUND_CACHE}.${reader}"; then
		set -- "${BACKGROUND_CACHE}.${reader}" "${2}" "${3}"
	else
		return 5
	fi

	# Step #6: Prepare GRUB to read the background image.
	if ! prepare_grub_to_access_device "`${grub_probe} --target=device "${1}"`"; then
		return 6
	fi

	# Step #7: Everything went fine, print out a message to stderr ...
	echo "Found background image: ${1}" >&2

	# ... and write our configuration snippet to stdout. Use the colors
	# desktop-base specified. If we're using a user-defined background, use
	# the default colors since we've got no idea how the image looks like.
	# If loading the background image fails, use the default theme.
	echo "insmod ${reader}"
	echo "if background_image `make_system_path_relative_to_its_root "${1}"`; then"
	if [ -n "${2}" ]; then
		echo "  set color_normal=${2}"
	fi
	if [ -n "${3}" ]; then
		echo "  set color_highlight=${3}"
	fi
	if [ -z "${2}" ] && [ -z "${3}" ]; then
		echo "  true"
	fi
	echo "else"
	set_default_theme "  "
	echo "fi"
}

# Earlier versions of grub-pc copied the default background image to /boot/grub
# during postinst. Remove those obsolete images if they haven't been touched by
# the user. They are still available under /usr/share/images/desktop-base/ if
# desktop-base is installed.
while read checksum background; do
	if [ -f "${background}" ] && [ "x`sha1sum "${background}"`" = "x${checksum}  ${background}" ]; then
		echo "Removing old background image: ${background}" >&2
		rm "${background}"
	fi
done <<EOF
648ee65dd0c157a69b019a5372cbcfea4fc754a5  debian-blueish-wallpaper-640x480.png
0431e97a6c661084c59676c4baeeb8c2f602edb8  debian-blueish-wallpaper-640x480.png
968ecf6696c5638cfe80e8e70aba239526270864  debian-blueish-wallpaper-640x480.tga
11143e8c92a073401de0b0fd42d0c052af4ccd9b  moreblue-orbit-grub.png
d00d5e505ab63f2d53fa880bfac447e2d3bb197c  moreblue-orbit-grub.png
f5b12c1009ec0a3b029185f6b66cd0d7e5611019  moreblue-orbit-grub.png
EOF

# Include the configuration of desktop-base if available.
if [ -f "/usr/share/desktop-base/grub_background.sh" ]; then
	. "/usr/share/desktop-base/grub_background.sh"
fi

# First check whether the user has specified a background image explicitly.
# If so, try to use it. Don't try the other possibilities in that case
# (#608263).
if [ -n "${GRUB_BACKGROUND+x}" ]; then
	set_background_image "${GRUB_BACKGROUND}" || set_default_theme
	exit 0
fi

# Next search for pictures the user put into /boot/grub/ and use the first one.
for background in *.jpg *.JPG *.jpeg *.JPEG *.png *.PNG *.tga *.TGA; do
	if set_background_image "${background}"; then
		exit 0
	fi
done

# Next try to use the background image and colors specified by desktop-base.
if set_background_image "${WALLPAPER}" "${COLOR_NORMAL}" "${COLOR_HIGHLIGHT}"; then
	exit 0
fi

# If we haven't found a background image yet, use the default from desktop-base.
case $GRUB_DISTRIBUTOR in
	Ubuntu|Kubuntu)
		;;
	Tanglu)
		if set_background_image "/usr/share/images/grub/grub.png"; then
			exit 0
		fi
		;;
	*)
		if set_background_image "/usr/share/images/desktop-base/desktop-grub.png"; then
			exit 0
		fi
		;;
esac

# Finally, if all of the above fails, use the default theme.
set_default_theme


Автор темы
NikolS
Сообщения: 19
Зарегистрирован: 22 янв 2017, 17:38
Благодарил (а): 4 раза
Поблагодарили: 1 раз

Настройка фонового изображение загрузчика Grub 2

Сообщение NikolS » 26 янв 2017, 17:48

в стоке if set_background_image "${WALLPAPER}" "${COLOR_NORMAL}" "${COLOR_HIGHLIGHT}"; then правил "/usr/share/images/desktop-base/desktop-grub.png" вместо {WALLPAPER}" следуя советам :smile:

Аватара пользователя

svm
Сообщения: 172
Зарегистрирован: 27 ноя 2016, 13:19
Решено: 4
Благодарил (а): 122 раза
Поблагодарили: 21 раз

Настройка фонового изображение загрузчика Grub 2

Сообщение svm » 26 янв 2017, 18:01

смена картинки на экране загрузки системы.
все операции делаем под root
sudo su
меняем дефолтные картинки на свои
/usr/share/plymouth/themes/mint-logo/mint-logo.png
/usr/share/plymouth/themes/mint-logo/mint-logo16.png
обновляем сделанные изменения в загрузчике
update-initramfs -u
update-grub2
Умный поймёт , а дураку и так всё равно.


Автор темы
NikolS
Сообщения: 19
Зарегистрирован: 22 янв 2017, 17:38
Благодарил (а): 4 раза
Поблагодарили: 1 раз

Настройка фонового изображение загрузчика Grub 2

Сообщение NikolS » 26 янв 2017, 18:57

svm, это ток минтовскую заставку поменяет

Аватара пользователя

symon2014
Сообщения: 1578
Зарегистрирован: 29 авг 2016, 02:17
Решено: 19
Откуда: Феодосия
Благодарил (а): 47 раз
Поблагодарили: 427 раз

Настройка фонового изображение загрузчика Grub 2

Сообщение symon2014 » 26 янв 2017, 19:48

После Grub2 версий выше 1.99 эти феньки не работают.
:sry:
Debian (9.1) , LMDE2 , LM 18.2 Mate . Благодарности складываем сюда ---> R320161344462

Аватара пользователя

root
Сообщения: 648
Зарегистрирован: 16 фев 2017, 17:03
Решено: 3
Откуда: г. Хабаровск
Благодарил (а): 192 раза
Поблагодарили: 152 раза

Настройка фонового изображение загрузчика Grub 2

Сообщение root » 16 фев 2017, 17:30

Для себя в Cherry Tree пару заметок сделал. Инструкция работала на Саре, перешел на Сирену, пока не тестил...

Как поменять фон в GRUB 2?
1) sudo apt-get install grub2-splashimages - установка готовых фоновых изображений (необязательный шаг)
2) sudo nemo /usr/share/images/grub - открытие папки с изображениями (где nemo - файловый менеджер)
3) sudo gedit /etc/default/grub - открытие текстового файла (где gedit - текстовые редактор)
4) GRUB_BACKGROUND="/usr/share/images/grub/Moraine_Lake_17092005.tga" -дописываем в него след. строку
5) sudo update-grub - обновляем настройки grub
6) перезагружаемся
Примечание : Если изображение (PNG, JPG/JPEG и TGA) не отображается, можно открыть его в полноэкранном режиме и нажать кнопку print screen
_____________________________________________________________
Дальше не по теме, но, возможно, кому-нибудь будет интересно.
sudo nano /etc/default/grub
GRUB_DEFAULT=0 - меню выбора по умолчанию
GRUB_TIMEOUT=3 - время ожидания выбора
GRUB_GFXMODE=1600x900x32 - разрешение экрана
GRUB_DISABLE_OS_PROBER=true - убрать проверку наличия других установленных ОС.

/etc/grub.d/
00_header отвечает за загрузку основных параметров и библиотек;
05_debian_theme отвечает за оформление внешнего вида;
10_linux отвечает за формирование записей в меню, соответствующих ОС-linux, в которой стоит GRUB;
20_linux_xen - аналогично предыдущему;
30_os-prober отвечает за обнаружение и включение в список остальных ОС;
40_custom и 41_custom - пользовательские скрипты.

/boot/grub/grub.cfg
Файл конфигурации с текущими настройками GRUB2. Является динамическим, постоянно обновляется при использовании команды sudo update-grub или обновлении ядра OS.

Как поменять цвет надписей в GRUB 2?
На фоне такой картинки серый цвет надписей смотрится как-то уныло. К сожалению, поменять цвет шрифта в файле настроек нельзя, поэтому нам придется лезть в настроечные скрипты, к счастью, в данном случае это совсем просто. Файл /etc/grub.d/40_custom предназначен для пользовательской настройки. Добавляем в конец:
set menu_color_normal=red/black
set menu_color_highlight=yellow/black
set color_normal=yellow/black

Установить можно четыре параметра: color_highlight, color_normal, menu_color_highlight, menu_color_normal. Все они должны быть вида color-foreground/color-background, устанавливается, соответственно, цвет текста и цвет фона.

• blue
• green
• cyan
• red
• magenta
• brown
• light-gray
• dark-gray
• light-blue
• light-green
• light-cyan
• light-red
• light-magenta
• yellow
• white
• black
Последний раз редактировалось пользователем 2 Dja; всего редактировалось раз: 16
Причина: BB-codes
User: adminka
OS: Linux Mint 18.2 Sonya Cinnamon :thumbs:
Kernel: 4.11.0-14-generic
Эмоджи смайлы                  


Аватара пользователя

symon2014
Сообщения: 1578
Зарегистрирован: 29 авг 2016, 02:17
Решено: 19
Откуда: Феодосия
Благодарил (а): 47 раз
Поблагодарили: 427 раз

Настройка фонового изображение загрузчика Grub 2

Сообщение symon2014 » 17 фев 2017, 05:05

Притомила меня эта тема, поэтому скажу свой рабочий вариант с ЛМ18.1 Мате (врядли от ДЕ зависит).
1. В файле /etc/default/grub строка - GRUB_GFXMODE="1024x768" (размер и разрешение меню).
2. В файле /etc/grub.d/06_mint_theme -
set menu_color_normal=yellow/black ( просто пункты)
set menu_color_highlight=red/light-gray (выделенный пункт )
это я у себя такие цвета поставил.
3. Картинка в формате .png кладётся в /boot/grub/картинка.png
4 . sudo update-grub
5.Всё.
:sry:
Debian (9.1) , LMDE2 , LM 18.2 Mate . Благодарности складываем сюда ---> R320161344462

Вернуться в «Параметры и оптимизация»